%simulation of genetic algorithm special case of wiener solution
warning('off','MATLAB:rankDeficientMatrix'); %supressing warnings
            %of matrix operations
warning('off','MATLAB:nearlySingularMatrix');


tic

%opening figures, needs to be open to switch between in non figure command
figure(1)
figure(2)

%parameters
multiMutRates={[7 6 5 4]};
multiItPerMut=[1];
multiPopSizes={[24 24 24 24]};
multiPopSizesTimes=[100];

for t=1:length(multiPopSizesTimes)
    costDiffRun=[]; 
    for q=1:multiPopSizesTimes(t)

        popSizes=multiPopSizes{t}; %number of individuals per population
        iterationsPerMutationForMainPopulation=multiItPerMut(t);
        mutationRates=multiMutRates{t}; %chance of mutation of bit: 1/(2^mutationRate)

        run=1;

        numberOfGenes=9; %i is generated when the inputs are generated and can be used in stead of actual number
        %mutationRates also decides how many populations are in simulation
        numberOfPopulations=length(mutationRates);
        numberOfMigrants=2; %maximum migrants between multiple populations
        K=20;      %number of samples used for avg in cost functiom
        samplesPerIteration=3; %number of samples increased per iteration
        sampleStop=590;
        sampleStart=1;
        maxInitial=0;
        maxNum=1;
        numberOfBits=10;%range
        iterationsPerSample = 1;





        W=analyticWeights(x_uref,x_1,s2,K,numberOfGenes);
        %preallocating memory
        cost={};
        for p=1:numberOfPopulations
            cost{p}=zeros(1,popSizes(p));
        end

        cost1={};
        for p=1:numberOfPopulations
            cost1{p}=zeros(1,popSizes(p));
        end

        %initialisation plot variables
        costInTime=[];
        refInTime=[];
        costRefInTime=[];
        p1InTime=[];
        p1InTimeNotAvg=[];
        costAnalyticInTime=[];
        numberUnderLimit=0;
        pOutInTime=[];
        pAnalInTime=[];


        %creating initial population
        Population={};
        for i=1:numberOfPopulations
            Population{i}=createSinglePop(numberOfGenes,popSizes(i),maxInitial);
        end
        iterationNumber=0;
        for n=sampleStart:samplesPerIteration:sampleStop%length(x_1) %main loop. n- current sample
            RefPopulation=createSinglePop(numberOfGenes,sum(popSizes),maxInitial); % a population 
                %without any evolutionary operations, to compare solution
            iterations=0;
            costAnalytic=costf2(x_1,x_uref,K,n,W(:,n)');
           
            while iterations<iterationsPerSample
                iterationNumber=iterationNumber+1;
                iterations=iterations+1;
                %finding the cost of each individual
                for p=1:numberOfPopulations
                    for i = 1:popSizes(p)
                        cost{p}(i)=costf(x_1,x_uref,K,n,Population{p}(:,i)');
                    end                
                    %sorting the individuals and cost from best to worst.
                    [cost{p},order]=sort(cost{p},2,'ascend');
                    Population{p}=Population{p}(:,order);
                    %migration
                    for k=1:numberOfPopulations
                        if p~=k
                            for curr=1:numberOfMigrants
                                if costf3(x_1,x_uref,K,n,...
                                    Population{k}(:,end-curr+1)') > cost{p}(curr)
                                Population{k}(:,end-curr+1)=Population{p}(:,curr);
                                end
                            end
                        end
                    end
                    %breeding
                    for i = 1:2:((popSizes(p)-2)/2)
                        Population{p}(:,end-i:end-i+1)=breedingIndividuals(...
                            Population{p}(:,i),Population{p}(:,i+1),maxNum,numberOfBits);
                    end
                    %mutation
                    if p~=1 || mod(iterationNumber,iterationsPerMutationForMainPopulation)==0
                        for i = 2:popSizes(p)
                            Population{p}(:,i)=mutateIndividual(Population{p}(:,i),...
                                mutationRates(p),maxNum,numberOfBits);
                        end
                    end
                end
            end %number of iterations
                if cost{1}(1) < 0.2*p1(x_1,n,K)%how many smpl had cost under 0,4*p1
                    numberUnderLimit=numberUnderLimit+1;
                end

            %signals used in plots
                p1InTime=[p1InTime p1(x_1,n,K)];
                p1InTimeNotAvg=[p1InTimeNotAvg p1(x_1,n+K,1)];
                costInTime=[costInTime costf2(x_1,x_uref,K,n,Population{p}(:,1)')]; %cost of best individuals
                costAnalyticInTime=[costAnalyticInTime costAnalytic];
                costRefInTime= [costRefInTime costf2(x_1,x_uref,K,n,...
                    ones(1,numberOfGenes))]; %cost of ref population

                pOutInTime=[pOutInTime abs(Population{1}(:,1)'*x_uref(:,n+K)-x_1(n+K))^2];
                pAnalInTime=[pAnalInTime abs(W(:,n)'*x_uref(:,n+K)-x_1(n+K))^2];

            %to see progress of simulation
            %animation
                figure(1)
             currFigure(1)
             hold off
             plot(costInTime)
             hold on
             plot(p1InTime,'r')
             plot(costAnalyticInTime,'--')
             legend('genetic','p1','analytic')
             title('cost of the genetic weights vs p1')
             xlim([0 160])
             ylim([0 0.01])

             %figure(2)
             currFigure(2)
             hold off
             plot(pOutInTime)
             hold on
             plot(p1InTimeNotAvg,'r')
             plot(pAnalInTime,'--')
             legend('genetic','p1','analytic')
             title('power of the genetic weights vs p1 and anal')
             xlim([0 160])
             ylim([0 0.1])

            if mod(n,10)==0
                disp(n)
            end
        end
        fprintf('avg cost: %d\n',sum(costInTime)/length(costInTime))
        fprintf('number of samples under limit: %d\n',numberUnderLimit)
        toc
        beep
        figure
        hold off
        plot(costInTime)
        hold on
        plot(costRefInTime,'r')
        plot(p1InTime,'--')
        plot(costAnalyticInTime,'--r')
        legend('genetic','ref weights','p1','analytic')
        title('cost of the wiener weights vs the genetic weights')
        xlabel('samples')
        ylabel('cost')
        ylim([0 0.015])
        save(sprintf('%d%d%d%d_%d_%d(%d).mat',mutationRates,popSizes(1),iterationsPerMutationForMainPopulation,q))
        if q==1
            AvgCostInTime=costInTime/multiPopSizesTimes(t);
        else   
            AvgCostInTime=AvgCostInTime+costInTime/multiPopSizesTimes(t);
        end
        costDiffRun=[costDiffRun;costInTime];


    end

    figure
    hold off;
    plot(costRefInTime,'r')
    hold on;
    plot(p1InTime,'--')
    plot(costAnalyticInTime,'r--')
    plot(AvgCostInTime)
    for s=1:size(costDiffRun,1)
        plot(costDiffRun(s,:),'m')
    end
    plot(AvgCostInTime)    
    legend('ref weights','p1','analytic','genetic avg','genetic all runs')
    title('cost of the wiener weights vs the genetic weights')
    xlabel('samples')
    ylabel('cost')
    ylim([0 0.015])
    print(gcf,'-dpng','-r200',sprintf('%d%d%d%d_%d_%d(%d).png',mutationRates,popSizes(1),iterationsPerMutationForMainPopulation,q))
end

warning('on','MATLAB:nearlySingularMatrix');
warning('on','MATLAB:rankDeficientMatrix');
