function C = IQ_demod(X,Fin,N)

%%I/Q demodulator %%
%


%Generate filter coefficients for Hilbert Transformer%
%coefficients are static so this is not a continouous operation%
Fs = Fin;  % Sampling Frequency
%N = 37;      % Order (getting this from input)
F = [15 57.5];  % Frequency Vector
A = [1 1];   % Amplitude Vector
W = 1;       % Weight Vector
b  = firpm(N, F/(Fs/2), A, W, 'hilbert');   %coefficients for Hilbert transformer

 %b = load('coeffs.txt');
 %N=length(b)-1;

% create result matrix with additional dimension for I and Q
% first dimension is channel, second is time, third is I and Q
sigdim=size(X);
C = zeros(sigdim(1),(sigdim(2)+N),2);
d = zeros(size(b));
d(length(d)/2)=1;

%convolute X through Hilbert transformer to create C(:,:,2)=im{X}, 
%delay X to create C(:,:,1)=re{X}
for k=1:1:sigdim(1)
    for n=(N+2):1:sigdim(2)        
        for m=1:1:(N+1)
            C(k,n,1) =C(k,n,1)+d(m)*X(k,(n-m+1),1);
            C(k,n,2) =C(k,n,2)+b(m)*X(k,(n-m+1),1);
        end
    end
end



return
