%%main correlation matrix calculation
%clear all;

l = 10;%5;                         %Signal length in microseconds
Fr =500;                      %Analog signal resolution in MHz
Fs= 125;                        %sample rate in MHz
N=37;                           %Filter order for Hilbert filter
div = 1;                        %Decimator factor
IFd = 125;                     %frequency of sine wave in regenerator

K = 20;                         % The number that is to be summed over in the excpectation value in the correlation matrix
M = 3;                          % Number of taps
 


X=signals2(l,Fr,pi/4,0);%generate signals 

dim = size(X);
Y=sample(X,Fs,Fr,l);
%C=IQ_demod(Y,Fs,N);               %run I/Q demod
D=decimator(C,div);              %run Decimator with divisor di

Dcom= D(:,:,1)+D(:,:,2)*1j;                               
sizeD= size(D);
s1=sizeD(1)-1;
s2=sizeD(2);
x_uref=zeros(s1*M,s2);
for i = 1:s1
    for j=1:s2-M
        for k=1:M
            x_uref(k+i*M-M,j) = Dcom(i+1,j+k-1);   % Generating signal matrix for antenna 2-6, dimension: (5*M,number of points in time) 
            
        end
        
    end
end   

x_1 =Dcom(1,:);                          %Signal at Reference channel, dimension:(1,number of points in time)
Cor=zeros(s1*M,s1*M,s2);
AutoCor=zeros(s1*M,s2);
for i=1:s1*M 
        for l=1:s2-K
            for k=1:K
                AutoCor(i,l)=AutoCor(i,l)+x_uref(i,l+k-1)'*x_1(l+k-1);  %Calculation of autocorrelation vector
                for j =1:s1*M
                    Cor(i,j,l)=Cor(i,j,l)+x_uref(i,l+k-1)'*x_uref(j,l+k-1);     %Calculation of correlation matrix i and j runs from 1 to 5*M and l is the considered point in time
                
                end
            
        end
        
    end
    
end  

Cor(:,:,:)=Cor(:,:,:)/K;     %Correlation matrix
AutoCor=AutoCor(:,:)/K;      %Autocorrelation vector

