--File: AdderTree_ent.vhd (vhdl)
--Complex tree adder of required size
--(c) Kongsberg Defence & Aerospace 2015
--$Id: ComplexAdderTree_ent.vhd 14777 2015-03-24 10:58:36Z mathiab $
--Author: Mathias By
--
--Assumptions: See architecture
--Description: See architecture

library ieee;
use ieee.numeric_std.all;
use ieee.std_logic_1164.all;

library GENETICALGLIB;
use GENETICALGLIB.GeneticAlgPrivate.all;

entity ComplexAdderTree is
   generic(
      c_NumAddends : natural := 9 
     ); 
   port (
      Rst_n       : in std_logic; -- Reset
      Clk         : in std_logic; -- Clock
      Addends     : in t_1xN16(0 to c_NumAddends-1);
      Result      : out t_Complex20;
      DataValid   : in std_logic;
      ResultValid : out std_logic 
   );
end ComplexAdderTree;
