--File: CostFunction_ent.vhd (vhdl)
-- Calculates H(W)*M*W - H(W)*C - H(C)*W + P1, Latency 18 Delay 10.
--(c) Kongsberg Defence & Aerospace 2015
--$Id: CostFunction_ent.vhd 14777 2015-03-24 10:58:36Z mathiab $
--Author: Mathias By
--
--Assumptions: See architecture
--Description: See architecture

library ieee;
use ieee.numeric_std.all;
use ieee.std_logic_1164.all;

library GENETICALGLIB;
use GENETICALGLIB.GeneticAlgPrivate.all;

entity CostFunction is
   port (
      Rst_n : in std_logic; -- Reset
      Clk   : in std_logic;  -- Clock
      InputMatrix    : in t_ATxAT16;
      InputVectorC   : in t_1xAT16;
      InputVectorW   : in t_1xAT10;
      DataValid      : in std_logic;
      P1             : in t_Complex20;
      Result         : out t_Complex20;
      ResultValid    : out std_logic;
      Ready          : out std_logic
   );
end CostFunction;
