--File: GeneticAlg_bdy.vhd (vhdl)
--package body which holds some functions defined in the package GeneticAlgPrivate_pck
--(c) Kongsberg Defence & Aerospace 2015
--$Id: GeneticAlgPrivate_bdy.vhd 14777 2015-03-24 10:58:36Z mathiab $
--Author: Mathias By
--
--Description: 
--package body which holds some functions defined in the package GeneticAlgPrivate_pck

package body GeneticAlgPrivate is
   --logartihm of number X base Base rounded up
   function logCeil(Base : positive;
                X    : positive) return natural is
      variable v_Rest         : natural := X;
      variable v_n            : natural := 0;
      variable v_Verification : natural;
   begin
      --Calculates (n)
      while (v_Rest >= 1) loop
         v_n    := v_n + 1;
         v_Rest := v_Rest / Base;
      end loop;
      return (v_n);
   end logCeil;


   --logartihm of number X base Base rounded down
   function logFloor(Base : positive;
                X    : positive) return natural is
      variable v_Rest         : natural := X;
      variable v_n            : natural := 0;
      variable v_Verification : natural;
   begin
      --Calculates (n)
      while (v_Rest > 1) loop
         v_n    := v_n + 1;
         v_Rest := v_Rest / Base;
      end loop;
      return (v_n);
   end logFloor;

   ----------------------------------------------------------------------------
   -- Procedures and functions
   ----------------------------------------------------------------------------

end GeneticAlgPrivate;
