--File: InsertionSort_ent.vhd (vhdl)
--top level sorting module. sort n elements in n clock cycles and transmitts the n/2 best of the elements.
--(c) Kongsberg Defence & Aerospace 2015
--$Id: InsertionSort_ent.vhd 14777 2015-03-24 10:58:36Z mathiab $
--Author: Mathias By
--
--Assumptions: See architecture
--Description: See architecture

library ieee;
use ieee.numeric_std.all;
use ieee.std_logic_1164.all;

library GENETICALGLIB;
use GENETICALGLIB.GeneticAlgPrivate.all;

entity InsertionSort is
   port (
      Rst_n                : in  std_logic; -- Reset
      Clk                  : in  std_logic; -- Clock
      InputWeights         : in  t_1xAT10;
      InputCost            : in  t_Complex20;
      InputCostAddress     : in std_logic_vector(6 downto 0);
      NewPopIn             : in  std_logic;
      InputWeightAddress   : in std_logic_vector(6 downto 0);
      OutputWeights        : out t_1xAT10;
      DataValid            : out std_logic
   );
end InsertionSort;
