--File: SerialCostFunction_ent.vhd (vhdl)
--The SerialCostFunction is a fully paralellised cost function with latency 19
--(c) Kongsberg Defence & Aerospace 2015
--$Id: SerialCostFunction_ent.vhd 14777 2015-03-24 10:58:36Z mathiab $
--Author: Mathias By
--
--Assumptions: See architecture
--Description: See architecture

library ieee;
use ieee.numeric_std.all;
use ieee.std_logic_1164.all;

library GENETICALGLIB;
use GENETICALGLIB.GeneticAlgPrivate.all;

entity SerialCostFunction is
   port (
      Rst_n                : in std_logic; -- Reset
      Clk                  : in std_logic;  -- Clock
      InputMatrix          : in t_ATxAT16;
      InputVectorC         : in t_1xAT16;
      InputVectorW         : in t_1xAT10;
      P1                   : in t_Complex20;
      NewPopIn             : in std_logic;
      Result               : out t_Complex20;
      NewPopOut            : out std_logic;
      OutputCostAddress    : out std_logic_vector(6 downto 0);
      OutputWeightAddress  : out std_logic_vector(6 downto 0)
   );
end SerialCostFunction;
