--File: SortingRegister_ent.vhd (vhdl)
--Sorts one input set per cycle using insertion sort. Transmitts only c_PopSize input sets per sort.
--(c) Kongsberg Defence & Aerospace 2015
--$Id: SortingRegister_ent.vhd 14777 2015-03-24 10:58:36Z mathiab $
--Author: Mathias By
--
--Description: See architecture

library ieee;
use ieee.numeric_std.all;
use ieee.std_logic_1164.all;

library GENETICALGLIB;
use GENETICALGLIB.GeneticAlgPrivate.all;

entity SortingRegister is
   port (
      Rst_n                : in std_logic; -- Reset
      Clk                  : in std_logic; -- Clock
      AddressIn            : in std_logic_vector(6 downto 0);
      InputCost            : in signed(19 downto 0); 
      NewPopIn             : in std_logic;
      TransmittingResult   : out std_logic;
      AddressOut           : out std_logic_vector(6 downto 0) 
   );
end SortingRegister;
